/*
 * $Id$
 *
 * [ Description ]
 * 
 */

#include "Behavioural/Stage_1_Ifetch/Predictor/Meta_Predictor/Two_Level_Branch_Predictor/Branch_History_Table/include/Parameters.h"
#include "Behavioural/Stage_1_Ifetch/Predictor/Meta_Predictor/Two_Level_Branch_Predictor/Branch_History_Table/include/Types.h"
#include <sstream>
using namespace std;

namespace morpheo                    {
namespace behavioural {
namespace stage_1_ifetch {
namespace predictor {
namespace meta_predictor {
namespace two_level_branch_predictor {
namespace branch_history_table {


  string Parameters::msg_error(void)
  {
    string msg = "";

    if (is_positive (_size_shifter) == false)
      {
	msg += "  - size_shifter must be > 0\n";
	msg += "    * size_shifter                    : " + toString(_size_shifter) + "\n";
      }

    if (is_positive (_nb_prediction) == false)
      {
	msg += "  - nb_prediction must be > 0\n";
	msg += "    * nb_prediction                   : " + toString(_nb_prediction) + "\n";
      }

    if (is_positive (_nb_branch_complete) == false)
      {
	msg += "  - nb_branch_complete must be > 0\n";
	msg += "    * nb_branch_complete              : " + toString(_nb_branch_complete) + "\n";
      }

    return msg;
  };

}; // end namespace branch_history_table
}; // end namespace two_level_branch_predictor
}; // end namespace meta_predictor
}; // end namespace predictor
}; // end namespace stage_1_ifetch

}; // end namespace behavioural
}; // end namespace morpheo              
